/*
 * StringFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_STRING_PARSER_H_
#define STRING_FROM_STRING_PARSER_H_

#include "String.h"
#include "StringFeatures.h"
#include "StringFromStringLexer.h"

namespace alib {

template<typename T>
struct stringApi;

} /* namespace alib */

namespace string {

class StringFromStringParser {
	std::vector<alphabet::Symbol> parseContent(std::istream&) const;

	StringFromStringLexer m_StringLexer;

	String parseString(std::istream&) const;
	String parseString(std::istream&, const std::set<FEATURES>& features) const;

	template<typename T> friend class alib::stringApi;
};

} /* namespace string */

#endif /* STRING_FROM_STRING_PARSER_H_ */
