/*
 * StringToStringComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "StringToStringComposer.h"
#include "CyclicString.h"
#include "LinearString.h"

#include "../StringApi.hpp"

namespace string {

void StringToStringComposer::Visit(void* userData, const CyclicString& string) const {
	std::ostream &out = *((std::ostream*) userData);

	out << "<";
	for(const auto& symbol : string.getContent()) {
		alib::stringApi<alphabet::Symbol>::compose(out, symbol);
	}
	out << ">";
}

void StringToStringComposer::Visit(void* userData, const LinearString& string) const {
	std::ostream &out = *((std::ostream*) userData);

	out << "\"";
	for(const auto& symbol : string.getContent()) {
		alib::stringApi<alphabet::Symbol>::compose(out, symbol);
	}
	out << "\"";
}

void StringToStringComposer::Visit(void* userData, const Epsilon&) const {
	std::ostream &out = *((std::ostream*) userData);

	out << "#E";
}

void StringToStringComposer::compose(std::ostream& out, const String& string) const {
	string.getData().Accept((void*) &out, *this);
}

} /* namespace string */
